unit UserGraphForm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Spin, WFComps, Menus, ExtDlgs, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Zahlenformat1: TMenuItem;
    OpenPictureDialog1: TOpenPictureDialog;
    Datei1: TMenuItem;
    Image1: TImage;
    Originalgre1: TMenuItem;
    AufOriginalgrezurcksetzen1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Datei1Click(Sender: TObject);
    procedure AufOriginalgrezurcksetzen1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure WMGetMinMaxInfo(var Msg: TMessage); message wm_GetMinMaxInfo;
  public
    { Public-Deklarationen }
    OriWidth, OriHeight: integer;
    Filename: string;
    procedure UpdateImage;
  end;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Filename := '*.BMP';
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ShowWindow(Handle, sw_Minimize);
  Action := caNone;
end;

procedure TForm1.Datei1Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then begin
    Filename := OpenPictureDialog1.Filename;
    UpdateImage;
  end;
end;

procedure TForm1.UpdateImage;
var BM: TBitmap;
    MetaFile: TMetaFile;
begin
  BM := TBitmap.Create;
  MetaFile := TMetaFile.Create;
  try
    if Uppercase(ExtractFileExt(Filename)) = '.BMP' then begin
      BM.LoadFromFile(Filename);
      Image1.Picture.Bitmap := BM;
      ClientWidth := BM.Width;
      ClientHeight := BM.Height;
      OriWidth := ClientWidth;
      OriHeight := ClientHeight;
    end else begin
      MetaFile.LoadFromFile(Filename);
      Image1.Picture.MetaFile := MetaFile;
      ClientWidth := MetaFile.Width;
      ClientHeight := MetaFile.Height;
      OriWidth := ClientWidth;
      OriHeight := ClientHeight;
    end;
  finally
    BM.Free;
    MetaFile.Free;
  end;
end;

procedure TForm1.WMGetMinMaxInfo;
type TMinMaxInfo = array[0..4] of TPoint;
     PMinMaxInfo = ^TMinMaxInfo;
var  MinMaxInfo: PMinMaxInfo;
begin
  inherited;
  MinMaxInfo := Pointer(Msg.lParam);
  MinMaxInfo^[3].x := 5;
  MinMaxInfo^[3].y := 5;
end;

procedure TForm1.AufOriginalgrezurcksetzen1Click(Sender: TObject);
begin
  ClientWidth := OriWidth;
  ClientHeight := OriHeight;
end;

end.
